const EventedWeakMap = class {
	constructor () {
		this.changeHandlers = []
		this.weakMap = new WeakMap()
	}
	delete (key) {
		const change = {key: key, oldValue: this.weakMap.get(key), value: undefined}
		this.weakMap.delete(key)
		for (const handler of this.changeHandlers) {
			handler(change)
		}
	}
	get (key) {
		return this.weakMap.get(key)
	}
	has (key) {
		return this.weakMap.has(key)
	}
	set (key, value) {
		const change = {key: key, oldValue: this.weakMap.get(key), value: value}
		this.weakMap.set(key, value)
		for (const handler of this.changeHandlers) {
			handler(change)
		}
	}
}

export default EventedWeakMap
