import fs from 'node:fs'

const FdStats = (fd) => {
	return new Promise((resolve, reject) => {
		fs.fstat(fd, (errorOrFalsyValue, statsIfNotErrorOrFalsyValue) => {
			if (errorOrFalsyValue) {
				reject(errorOrFalsyValue)
			}
			else {
				resolve(statsIfNotErrorOrFalsyValue)
			}
		})
	})
}

export default FdStats
