import QcQueueIsPlaying from './QcQueueIsPlaying.js'
import QcQueuePositions from './QcQueuePositions.js'
import qcQueueMap from './qcQueueMap.js'

const NumberGroups = (positions) => {
	const groups = []
	for (const position of positions) {
		const number = qcQueueMap.get(position).bumpNumber
		if (groups.length !== 0 && number === groups.at(-1).number) {
			groups.at(-1).positions.push(position)
		}
		else {
			groups.push({positions: [position], number: number})
		}
	}
	return groups
}
const QcBumpGroups = (arg) => {
	const positions = arg !== undefined && arg.withoutPositions !== undefined ? QcQueuePositions().filter((position) => {
		return !arg.withoutPositions.has(position)
	}) : QcQueuePositions()
	if (QcQueueIsPlaying()) {
		if (positions.length === 0) {
			return []
		}
		const groups = [{positions: [positions[0]]}]
		if (qcQueueMap.get(positions[0]).playlist === undefined) {
			groups.push(...NumberGroups(positions.slice(1)))
		}
		else {
			const currentPlaylist = qcQueueMap.get(positions[0]).playlist
			const currentPlaylistLastIndex = positions.findLastIndex((position) => {
				return qcQueueMap.get(position).playlist === currentPlaylist
			})
			if (currentPlaylistLastIndex === 0) {
				groups.push(...NumberGroups(positions.slice(1)))
			}
			else {
				let currentPlaylistGroupFirstIndex = currentPlaylistLastIndex
				while (currentPlaylistGroupFirstIndex > 1 && qcQueueMap.get(positions[currentPlaylistGroupFirstIndex - 1]).playlist === currentPlaylist) {
					currentPlaylistGroupFirstIndex--
				}
				groups.push(...NumberGroups(positions.slice(1, currentPlaylistGroupFirstIndex)))
				groups.push({positions: positions.slice(currentPlaylistGroupFirstIndex, currentPlaylistLastIndex + 1)})
				groups.push(...NumberGroups(positions.slice(currentPlaylistLastIndex + 1)))
			}
		}
		return groups
	}
	return NumberGroups(positions)
}

export default QcBumpGroups
