import QcsMediaExists from './QcsMediaExists.js'
import CollabPositionComparison from './CollabPositionComparison.js'
import qcPlayHistoryMap from './qcPlayHistoryMap.js'

let cache = null
const QcPlayHistoryPositions = () => {
	if (cache === null) {
		cache = [...qcPlayHistoryMap.keys()].filter((position) => {
			const info = qcPlayHistoryMap.get(position)
			return QcsMediaExists(info.track) && (info.playlist === undefined || QcsMediaExists(info.playlist))
		})
		cache.sort(CollabPositionComparison)
	}
	return cache
}
qcPlayHistoryMap.onChange(() => {
	cache = null
})
QcsMediaExists.onChange(() => {
	cache = null
})

export default QcPlayHistoryPositions
