import qcsCollabMap from './qcsCollabMap.js'

const maps = new Map()
for (const [key, value] of qcsCollabMap) {
	const matchOrNull = key.match(/^media-([^-]*)-playlists-([^-]*)-info$/)
	if (matchOrNull !== null) {
		const [, track, playlist] = matchOrNull
		if (!maps.has(playlist)) {
			maps.set(playlist, new Map())
		}
		maps.get(playlist).set(JSON.parse(value).position, track)
	}
}
qcsCollabMap.changeHandlers.push((change) => {
	const matchOrNull = change.key.match(/^media-([^-]*)-playlists-([^-]*)-info$/)
	if (matchOrNull !== null) {
		const [, track, playlist] = matchOrNull
		if (change.oldValue !== '') {
			maps.get(playlist).delete(JSON.parse(change.oldValue).position)
			if (maps.get(playlist).size === 0) {
				maps.delete(playlist)
			}
		}
		if (change.value !== '') {
			if (!maps.has(playlist)) {
				maps.set(playlist, new Map())
			}
			maps.get(playlist).set(JSON.parse(change.value).position, track)
		}
	}
})
const emptyMap = new Map()
const QcPlaylistMap = (playlist) => {
	return maps.has(playlist) ? maps.get(playlist) : emptyMap
}
QcPlaylistMap.onChange = (fn) => {
	qcsCollabMap.changeHandlers.push((change) => {
		if (/^media-[^-]*-playlists-[^-]*-info$/.test(change.key)) {
			fn()
		}
	})
}
export default QcPlaylistMap
