import QcsMediaExists from './QcsMediaExists.js'
import CollabPositionComparison from './CollabPositionComparison.js'
import qcQueueMap from './qcQueueMap.js'

let cache = null
const QcQueueGroups = () => {
	if (cache === null) {
		const positions = [...qcQueueMap.keys()].filter((position) => {
			const value = qcQueueMap.get(position)
			return QcsMediaExists(value.track) && (value.playlist === undefined || QcsMediaExists(value.playlist))
		})
		positions.sort(CollabPositionComparison)
		let currentPlaylistOrUndefined
		cache = []
		for (const position of positions) {
			const value = qcQueueMap.get(position)
			if (currentPlaylistOrUndefined !== undefined && value.playlist === currentPlaylistOrUndefined) {
				cache[cache.length - 1].push(position)
			}
			else {
				cache.push([position])
			}
			currentPlaylistOrUndefined = value.playlist
		}
	}
	return cache
}
qcQueueMap.onChange(() => {
	cache = null
})
QcsMediaExists.onChange(() => {
	cache = null
})

export default QcQueueGroups
