import collabThread from './collabThread.js'
import fs from 'node:fs'
import FsPath from 'node:path'
import qcsCollabMap from './qcsCollabMap.js'
import qsBundledQcSetupJsHash from './qsBundledQcSetupJsHash.js'
import qsCollabMapTimer from './qsCollabMapTimer.js'
import qpsPackage from './qpsPackage.js'
import qsQcCssHash from './qsQcCssHash.js'

import './qsCollabMapSetup.js'

const splitTemplate = (
	(await fs.promises.readFile(FsPath.join(qpsPackage, 'src', 'qcTemplate.html'), {encoding: 'utf8'}))
	.split('${}')
)
const prefix = (
	splitTemplate[0]
	+ encodeURIComponent(qsQcCssHash)
	+ splitTemplate[1]
	+ encodeURIComponent(qsBundledQcSetupJsHash)
	+ splitTemplate[2]
)
const suffix = splitTemplate[3]
const QsQcHtml = () => {
	return prefix + JSON.stringify({
		collabMapOps: [...qcsCollabMap.ops.values()],
		qsCollabMapTime: qsCollabMapTimer.time,
		qsCollabThread: collabThread,
	}).replaceAll('<', '\\u003C') + suffix
}

export default QsQcHtml
