import YtChannelTabContentResults from './YtChannelTabContentResults.js'
import bufferHttpResBody from './bufferHttpResBody.js'
import HttpResAsJsonValue from './HttpResAsJsonValue.js'
import HttpsGetRes from './HttpsGetRes.js'
import qsWriteDebuggingInfo from './qsWriteDebuggingInfo.js'
import ThroweeAsJsonValue from './ThroweeAsJsonValue.js'
import Ungzipped from './Ungzipped.js'
import YtInitialData from './YtInitialData.js'

const QsYtChannelTabResultsOrNull = async (channel, channelTitle, tabName) => {
	let resOrNull = null
	let resBodyOrNull = null
	let threw = false
	let throweeIfThrew
	let resultsIfNotThrew
	try {
		resOrNull = await HttpsGetRes(
			'https://www.youtube.com/channel/' + encodeURIComponent(channel) + '/' + tabName,
			{headers: {'Accept-Encoding': 'gzip', 'Accept-Language': 'en-US'}},
		)
		resBodyOrNull = await bufferHttpResBody(resOrNull)
		resultsIfNotThrew = YtChannelTabContentResults((
			YtInitialData((await Ungzipped(resBodyOrNull)).toString())
			.contents
			.twoColumnBrowseResultsRenderer
			.tabs
		).find((tab) => {
			return tab.tabRenderer !== undefined && tab.tabRenderer.content !== undefined
		}).tabRenderer.content, channelTitle)
	}
	catch (throwee) {
		threw = true
		throweeIfThrew = throwee
	}
	qsWriteDebuggingInfo('qsYtChannelTabResultsOrNullInfo', {
		channel: channel,
		channelTitle: channelTitle,
		tabName: tabName,
		resBodyOrNull: resBodyOrNull === null ? null : resBodyOrNull.toString('base64'),
		resOrNull: resOrNull === null ? null : HttpResAsJsonValue(resOrNull),
		threw: threw,
		throweeIfThrew: threw ? ThroweeAsJsonValue(throweeIfThrew) : null,
	})
	return threw ? null : resultsIfNotThrew
}

export default QsYtChannelTabResultsOrNull
