import assert from './assert.js'
import YtTextAsString from './YtTextAsString.js'

const YtResultDuration = (value) => {
	const parts = YtTextAsString(value).split(':').map((substring) => {
		const substringWithoutCommas = substring.replaceAll(',', '')
		assert(/^\d{1,6}$/.test(substringWithoutCommas))
		return parseInt(substringWithoutCommas)
	})
	if (parts.length === 2) {
		const [minutes, seconds] = parts
		return (60 * minutes) + seconds
	}
	if (parts.length === 3) {
		const [hours, minutes, seconds] = parts
		return (3600 * hours) + (60 * minutes) + seconds
	}
	assert(false)
}

export default YtResultDuration
