import qcsCollabMap from './qcsCollabMap.js'

const qcRecentsMap = new Map()
for (const [key, value] of qcsCollabMap) {
	const matchOrNull = key.match(/^media-([^-]*)-recentsInfo$/)
	if (matchOrNull !== null) {
		const [, media] = matchOrNull
		qcRecentsMap.set(JSON.parse(value).position, media)
	}
}
qcsCollabMap.changeHandlers.push((change) => {
	const matchOrNull = change.key.match(/^media-([^-]*)-recentsInfo$/)
	if (matchOrNull !== null) {
		const [, media] = matchOrNull
		if (change.oldValue !== '') {
			qcRecentsMap.delete(JSON.parse(change.oldValue).position)
		}
		if (change.value !== '') {
			qcRecentsMap.set(JSON.parse(change.value).position, media)
		}
	}
})
qcRecentsMap.onChange = (fn) => {
	qcsCollabMap.changeHandlers.push((change) => {
		if (/^media-[^-]*-recentsInfo$/.test(change.key)) {
			fn()
		}
	})
}

export default qcRecentsMap
