import QcBumpNumber from './QcBumpNumber.js'
import QcBumpGroups from './QcBumpGroups.js'
import QcQueuePlayInfo from './QcQueuePlayInfo.js'
import qcSkipBack from './qcSkipBack.js'
import QcsMediaExists from './QcsMediaExists.js'
import qcsCollabMap from './qcsCollabMap.js'
import QcQueuePositions from './QcQueuePositions.js'
import QcQueueIsPlaying from './QcQueueIsPlaying.js'
import assert from './assert.js'
import CollabPosition from './CollabPosition.js'

const qcUnbumpTrack = (track) => {
	let skippedBack = false
	if (QcsMediaExists(track)) {
		const queueInfoAsJsonOrEmptyString = qcsCollabMap.get('media-' + track + '-queueInfo')
		if (queueInfoAsJsonOrEmptyString !== '') {
			const positions = QcQueuePositions()
			const currentPosition = JSON.parse(queueInfoAsJsonOrEmptyString).position
			const currentIndex = positions.indexOf(currentPosition)
			assert(currentIndex !== -1)
			let unbumped = false
			if (currentIndex === 0 && QcQueueIsPlaying()) {
				const playInfo = QcQueuePlayInfo()
				if (playInfo.sourceTrack === track && playInfo.sourcePlaylist === undefined) {
					QcQueueIsPlaying.set(false)
					unbumped = true
				}
				else {
					skippedBack = qcSkipBack()
					unbumped = skippedBack
				}
			}
			if (!unbumped) {
				const groups = QcBumpGroups()
				const groupIndex = groups.findIndex((group) => {
					return group.positions.includes(currentPosition)
				})
				assert(groupIndex !== -1)
				if (groupIndex === groups.length - 1) {
					qcsCollabMap.delete('media-' + track + '-queueInfo')
				}
				else {
					const newPosition = CollabPosition(groups[groupIndex + 1].positions.at(-1), groupIndex === groups.length - 2 ? null : groups[groupIndex + 2].positions[0])
					qcsCollabMap.set('media-' + track + '-queueInfo', JSON.stringify({
						position: newPosition,
						bumpNumber: QcBumpNumber(newPosition, QcBumpGroups({withoutPositions: new Set([currentPosition])})),
					}))
				}
			}
		}
	}
	return {skippedBack: skippedBack}
}

export default qcUnbumpTrack
