import fs from 'node:fs'

const Name = (cliArg) => {
	return cliArg.endsWith('.js') ? cliArg.slice(0, -3) : cliArg
}
const currentName = Name(process.argv[2])
const newName = Name(process.argv[3])
await fs.promises.copyFile(currentName + '.js', newName + '.js')
const regExp = new RegExp('\\b' + currentName + '\\b', 'g')
for (const child of await fs.promises.readdir('.')) {
	if (child.endsWith('.js')) {
		const js = await fs.promises.readFile(child, {encoding: 'utf8'})
		const newJs = js.replace(regExp, newName)
		if (newJs !== js) {
			await fs.promises.writeFile(child, newJs)
		}
	}
}
await fs.promises.rm(currentName + '.js')
