import qpsPackageInfo from './qpsPackageInfo.js'
import DateAsJsonValue from './DateAsJsonValue.js'
import FsPath from 'node:path'
import qsArg from './qsArg.js'
import qsDataDir from './qsDataDir.js'
import qpsPackage from './qpsPackage.js'
import qsResetMaintenanceTimeout from './qsResetMaintenanceTimeout.js'
import qsWriteDebuggingInfo from './qsWriteDebuggingInfo.js'
import replaceQs from './replaceQs.js'

import './qsCollabMapSetup.js'
import './qsHttpServerSetup.js'

qsResetMaintenanceTimeout()
qsWriteDebuggingInfo('qsInfo', {
	date: DateAsJsonValue(new Date()),
	processArch: process.arch,
	processArgv: process.argv,
	processArgv0: process.argv0,
	processCwd: process.cwd(),
	processEnv: process.env,
	processExecArgv: process.execArgv,
	processPlatform: process.platform,
	processVersions: process.versions,
	qsDataDir: qsDataDir,
	qpsPackageInfoVersion: qpsPackageInfo.version,
	qpsPackageInfoName: qpsPackageInfo.name,
})
if (qsArg.sequenceIndex === 0) {
	console.log('QueueShare is now available at http://localhost:29749')
}
if (qsArg.options.dev) {
	;(await import('chokidar')).watch([
		FsPath.join(qpsPackage, 'src'),
		FsPath.join(qpsPackage, 'package.json'),
		FsPath.join(qpsPackage, 'npm-shrinkwrap.json'),
	], {disableGlobbing: true, ignoreInitial: true}).on('all', replaceQs)
}
