import qsWriteDebuggingInfo from './qsWriteDebuggingInfo.js'
import ThroweeAsJsonValue from './ThroweeAsJsonValue.js'

const qsBufferHttpServerReqBodyOrNull = (req) => {
	return new Promise((resolve) => {
		const chunks = []
		req.on('data', (chunk) => {
			chunks.push(chunk)
		})
		req.on('end', () => {
			resolve(Buffer.concat(chunks))
		})
		req.on('error', (error) => {
			resolve(null)
			qsWriteDebuggingInfo('qsBufferHttpServerReqBodyOrNullError', ThroweeAsJsonValue(error))
		})
	})
}

export default qsBufferHttpServerReqBodyOrNull
