import qsArg from './qsArg.js'
import collabThread from './collabThread.js'
import fs from 'node:fs'
import FsPath from 'node:path'
import processNewlineDelimitedFile from './processNewlineDelimitedFile.js'
import qsDataDir from './qsDataDir.js'
import Queue from './Queue.js'

const file = FsPath.join(qsDataDir, 'debug.ndjson')
if (!qsArg.dev && !qsArg.infiniteDebugFile) {
	await (async () => {
		let length = 0
		const lines = new Queue()
		await fs.promises.appendFile(file, '')
		await processNewlineDelimitedFile(file, (line) => {
			length += line.length
			lines.append(line)
			while (length > 10000000) {
				length -= lines.firstValue().length
				lines.deleteFirstValue()
			}
		})
		let newFileContents = ''
		while (!lines.isEmpty()) {
			newFileContents += lines.firstValue() + '\n'
			lines.deleteFirstValue()
		}
		const tempFile = FsPath.join(qsDataDir, 'temp_debug.ndjson')
		await fs.promises.writeFile(tempFile, newFileContents)
		await fs.promises.rename(tempFile, file)
	})()
}
const fileAppendStream = fs.createWriteStream(file, {flags: 'a'})
const qsWriteDebuggingInfo = (kind, value) => {
	fileAppendStream.write(JSON.stringify({
		collabThread: collabThread,
		kind: kind,
		performanceNow: performance.now(),
		stack: (new Error()).stack,
		value: value,
	}) + '\n')
}

export default qsWriteDebuggingInfo
